#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package}.command;

import org.eclipse.jface.dialogs.MessageDialog;

import com.modeliosoft.modelio.api.log.ILogService;
import com.modeliosoft.modelio.api.mdac.IMdac;
import com.modeliosoft.modelio.api.mdac.commands.DefaultMdacContextualCommand;
import com.modeliosoft.modelio.api.model.IModelingSession;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.module.IMdacConfiguration;
import com.modeliosoft.modelio.api.utils.ObList;

/**
 * Implementation of the IMdacContextualCommand interface.
 * <br>The MDAC contextual commands are displayed in the contextual menu and in the specific toolbar of each mdac property page.
 * <br>The developer may inherit the DefaultMdacContextualCommand class which contains a default standard contextual command implementation.
 *
 */
public class HelloWorldCommand extends DefaultMdacContextualCommand {

	private ILogService logService;

	/**
	 * Constructor.
	 */
	public HelloWorldCommand() {
		super();
		// services logs
		logService = Modelio.getInstance().getLogService();
	}

	/**
	 * @see com.modeliosoft.modelio.api.mdac.commands.DefaultMdacContextualCommand${symbol_pound}accept(com.modeliosoft.modelio.api.utils.ObList,
	 *      com.modeliosoft.modelio.api.mdac.IMdac)
	 */
	public boolean accept(ObList<IElement> selectedElements, IMdac mdac) {
		// Check that there is only one selected element
		return selectedElements.size() == 1;
	}

	/**
	 * @see com.modeliosoft.modelio.api.mdac.commands.DefaultMdacContextualCommand${symbol_pound}actionPerformed(com.modeliosoft.modelio.api.utils.ObList,
	 *      com.modeliosoft.modelio.api.mdac.IMdac)
	 */
	public void actionPerformed(ObList<IElement> selectedElements, IMdac mdac) {
		
		logService.info(mdac, "HelloWorldCommand - actionPerformed(...)");
		
		IModelingSession session = Modelio.getInstance().getModelingSession();
		IPackage root = session.getModel().getRoot();
		IMdacConfiguration configuration = mdac.getConfiguration();
		
		IModelElement modelelt = (IModelElement)selectedElements.get(0);
		MessageDialog.openInformation(null, "Hello", modelelt.getName());
	}


}
