#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package}.impl;

import com.modeliosoft.modelio.api.mdac.AbstractJavaMdac;
import com.modeliosoft.modelio.api.mdac.IMdacSession;
import com.modeliosoft.modelio.api.mdac.IParameterEditionModel;
import com.modeliosoft.modelio.api.model.IModelingSession;
import com.modeliosoft.modelio.api.model.extension.IModule;
import com.modeliosoft.modelio.api.module.IMdacConfiguration;

/**
 * Implementation of the IMdac interface.
 * <br>All Modelio java modules should inherit from this class.
 * 
 */
public class ${moduleName}Mdac extends AbstractJavaMdac {

	private ${moduleName}PeerMdac peerMdac = null;

	private ${moduleName}Session session = null;

	public ${moduleName}PeerMdac getPeerMdac() {
		return this.peerMdac;
	}

	/**
	 * Return the session attached to the current module.
	 * <p>
	 * <p>
	 * This session is used to manage the module lifecycle by declaring the
	 * desired implementation on start, select... methods.
	 */
	public IMdacSession getSession() {
		return this.session;
	}

	/**
	 * Method automatically called just after the creation of the module.
	 * <p>
	 * <p>
	 * The module is automatically instanciated at the beginning of the MDA
	 * lifecycle and constructor implementation is not accessible to the module
	 * developer.
	 * <p>
	 * <p>
	 * The <code>init</code> method allows the developer to execute the desired initialization code at this step. For
     * example, this is the perfect place to register any IViewpoint this mdac provides.
	 *
	 *
	 * @see com.modeliosoft.modelio.api.mdac.AbstractJavaMdac${symbol_pound}init()
	 */
	@Override
	public void init() {
		// Add the module initialization code
	    super.init();
	}

    /**
     * Method automatically called just before the disposal of the mdac.
     * <p>
     * <p>
     * 
     * 
     * The <code>uninit</code> method allows the developer to execute the desired un-initialization code at this step.
     * For example, if IViewpoints have been registered in the {@link #init()} method, this method is the perfect place
     * to remove them.
     * <p>
     * <p>
     * 
     * This method should never be called by the developer because it is already invoked by the tool.
     * 
     * @see com.modeliosoft.modelio.api.mdac.AbstractJavaMdac${symbol_pound}uninit()
     */
    @Override
    public void uninit() {
        // Add the module un-initialization code
        super.uninit();
    }
    
	/**
	 * Builds a new module.
	 * <p>
	 * <p>
	 * This constructor must not be called by the user. It is automatically
	 * invoked by Modelio when the module is installed, selected or started.
	 */
	public ${moduleName}Mdac(IModelingSession modelingSession, IModule model, IMdacConfiguration configuration) {
		super(modelingSession, model, configuration);
		this.session = new ${moduleName}Session(this);
		this.peerMdac = new ${moduleName}PeerMdac(this);
		this.peerMdac.init();
	}

	/**
	 * @see com.modeliosoft.modelio.api.mdac.AbstractJavaMdac${symbol_pound}getParametersEditionModel()
	 */
	@Override
	public IParameterEditionModel getParametersEditionModel() {
		
		return this.parameterEditionModel;
	}
	
    public String getMdacImage() {
        return "/res/icons/module_16.png";
    }

}
