#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package}.impl;

import com.modeliosoft.modelio.api.modelio.Version;
import com.modeliosoft.modelio.api.module.IMdacConfiguration;

import ${package}.api.I${moduleName}PeerMdac;

/**
 * Implementation of Mdac services
 * <br>When a mdac is built using the MDA Modeler tool, a public interface is generated and accessible for the other mdac developments.
 * <br>The main class that allows developpers to get specific mdac services has to implement the current interface.
 * <br>Each mda component brings a specific interface that inherit from this one and gives all the desired mdac services.
 *
 */
public class ${moduleName}PeerMdac implements I${moduleName}PeerMdac {
    private ${moduleName}Mdac module;
	
	public ${moduleName}PeerMdac(${moduleName}Mdac statModuleMdac) {
		super();
		this.module = statModuleMdac;
	}

	public void init() {

	}

	/**
	 * @see com.modeliosoft.modelio.api.module.IPeerMdac${symbol_pound}getConfiguration()
	 */
	public IMdacConfiguration getConfiguration() {
		return this.module.getConfiguration();
	}

	/**
	 * @see com.modeliosoft.modelio.api.module.IPeerMdac${symbol_pound}getDescription()
	 */
	public String getDescription() {
	    return this.module.getDescription();
	}

	/**
	 * @see com.modeliosoft.modelio.api.module.IPeerMdac${symbol_pound}getName()
	 */
	public String getName() {
	    return this.module.getName();
	}

	/**
	 * @see com.modeliosoft.modelio.api.module.IPeerMdac${symbol_pound}getVersion()
	 */
	public Version getVersion() {
	    return this.module.getVersion();
	}

}
